/*******************************************************************************

    TIMER REGRESSIVO  DE 30 SEGUNDOS


    AUTOR: CLAUDIO LRIOS

    DATA: 02/05/2019

    COM PIC 16F628A

    DISPLAYS DE 7 SEGUIMENTOS (OPCIONAL CATODO OU ANODO COMUM)
    IMPORTANTE: USE O ESQUEMA CORRETO CONFORME A OPO)

    OBS. MONTAGEM  DE NATUREZA DIDTICA

    ESTE ARQUIVO  PARTE INTEGRANTE DO BLOG PICSOURCE


*******************************************************************************/

 //   #define ANODO_COMUM  //descomente para anodo comum

// Comente o acima para catodo comum
//=============================================================================/


#include <16F628A.h>
#use delay(clock=4000000)
#fuses NOWDT,HS, NOPUT, NOPROTECT, NOBROWNOUT, NOMCLR, NOLVP, NOCPD
#zero_ram

//BYTE
#byte portb = 0x06
#byte porta = 0x05
#byte trisa = 0x85
#byte trisb = 0x86

//BIT
#bit  sw_start  = 0x5.5
#bit  sw_stop = 0x5.4
#bit  sw_init  = 0x5.3
#bit  beep  = 0x5.2


//constantes para converso 7 seguimentos

//                         PGFEDCBA   SEGUIMENTOS
//                   PORTB 76543210
int8 const NUM[] = {     0B00111111,//0
                         0B00000110,//1
                         0B01011011,//2
                         0B01001111,//3
                         0B01100110,//4
                         0B01101101,//5
                         0B01111101,//6
                         0B00000111,//7
                         0B01111111,//8
                         0B01101111 //9
                                        };

 //variveis globais
 int8 segundos;
 int1 f_bipar,f_trava;

 /******************************************************************************
           MULTIPLEXA OS DISPLAYS
******************************************************************************/

 void multiplexa(){
    static int1 vez;
//    static int8 vel;
  
 //   if(++vel) return;
    

  
    porta&=0xf3;//apaga display (resetando)
    #ifdef ANODO_COMUM
    portb=0xff;
    #else
    portb=0;
    #endif   

     
     if(vez){
       portb=num[segundos%10];
       #ifdef ANODO_COMUM
       portb=~portb;
       #endif
       porta=porta&0xfe;
       porta= porta|2;
       vez=0;
     }
     else {
       portb=num[segundos/10];
       #ifdef ANODO_COMUM
       portb=~portb;
       #endif
       porta=porta&0xfd;
       porta= porta|1;
       vez=1;
     }

    } 

/******************************************************************************
           TESTA INTERRUPTORES DATILARES
******************************************************************************/
void testa_ajuste(){
 
  
      

   if(!sw_start&&!f_trava) {//(start)
    f_trava=1;    
    if(segundos>0) enable_interrupts(int_timer0);
   }

   if(!sw_stop){
     disable_interrupts(int_timer0);
     f_trava=0;
   }
   
   if(!sw_init&&!f_trava)segundos=30;
  
}

/******************************************************************************
           ROTINA PARA PRODUO DE 'BEEP'
******************************************************************************/


//rotina de produo de som no disco piezoeletrico
 void bipar() {
   int16 c;
   int8 a;
   if(!f_bipar)return;


    porta|=0x0f;//liga todos catodos '-'
    #ifdef ANODO_COMUM
    portb=0xbf;//liga seguimento 'g'
    #else
    portb=0x40;//liga seguimento 'g'
    #endif


    for(a=0;a<5;a++){
    for(c=0; c<2500; c++) {

      beep=1;
      delay_us(72); //ajuste conforme freq. ressonancia do piezoeletrico
      beep=0;
      delay_us(132);
    }
    delay_ms(100);//delay entre beeps
  }
   f_bipar=0;
   f_trava=0;
 }


#INT_TIMER0
void INT_TIMER0_ISR(){
 static int32 cnt32;

 //--------------------------------------------------------
//gera 1 segundos com metodo de acumulo de erro e pode ser usado
// para cristais com valores quebrados das mais variadas frequencias
// ajuste o timer para o prescaller igual abaixo no main

 #define presc  64 // valor do prescaller do timer usado (8bits)
 #define fator  (256*presc*4)
 #define f_xtal 4000000  //frequencia do cristal usado (mesmo do cabealho)
     

   cnt32+=fator;
   if(cnt32>=f_xtal){
     cnt32-=f_xtal;

     if(segundos)segundos--;
     if(!segundos) {
      //  rele=0;//desliga o rele de sada
        disable_interrupts(int_timer0);//para a contagem
        
        f_bipar=1;
     }
   }
 }

//==============================================================================
//         ROTINA MAIN
//==============================================================================

void main() {

   setup_counters(RTCC_INTERNAL,RTCC_DIV_64);
   setup_timer_1(T1_DISABLED);
   setup_timer_2(T2_DISABLED,0,1);
   setup_comparator(NC_NC_NC_NC);
   setup_vref(FALSE);
   trisa=0b11111000;//sentido fixo das portas
   trisb=0;//idem
   porta=0;//desliga displays anodo ou catodo
   enable_interrupts(global);//ativa chave de interrupes
   segundos=30;



//==============================================================================
//         LAO DE REPETIO PRINCIPAL
//==============================================================================

   for(;;){
     multiplexa();
     testa_ajuste();
     bipar();
     delay_ms(1);
   }
}
